#include <Keypad.h>
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif

// Which pin on the Arduino is connected to the NeoPixels?
#define PIN        11 // On Trinket or Gemma, suggest changing this to 1

// How many NeoPixels are attached to the Arduino?
#define NUMPIXELS 10 // Popular NeoPixel ring size

Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

const byte ROWS = 4;
const byte COLS = 4;
int rnd = 0;       // for counting the amount of available spaces
int count = 0;     // allows reset
int color = 0;     // for switching colors
int numb = 0;      // for correction factor for keypad to neopixel
int i = 0;
int j = 0;
int X = 0;
int Y = 0;
int state = 1;

char hexaKeys[ROWS][COLS] = {
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};

byte rowPins[ROWS] = {9, 8, 7, 6};
byte colPins[COLS] = {5, 4, 3, 2};


Keypad customKeypad = Keypad(makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS);

byte LED[3][3] = { // set up array for determining open player 1 or 2
  {0,0,0},
  {0,0,0},
  {0,0,0},
};


void setup() {
  
  Serial.begin(9600);   //for serial monitor
  pixels.begin();       // setsup neopixel
  pixels.setBrightness(80);
}

void loop() {

  char customKey = customKeypad.getKey();

  color = count % 2;        // can switches colors
  if(customKey > 0){        //this was essential to keep numb the same through states
  numb = customKey - 49;    //correction factor for keypad to neopixel
  }

  switch (state) { 
    
      //this works
    case 1: // player selection: blue or red first?
    
      if (numb >= 0 &&  numb <= 8 && customKey) { //red first
        
 /*       Serial.print(" customKey = ");
        Serial.print(customKey);
        
        Serial.print(" state 1  ");
        Serial.println(" blue first");
  */    count = 0;
        state = 2;
        break;
       }

       if (numb >= 8 || numb == -14 && customKey) { //blue first
  //      Serial.print(" state 1  ");
  //      Serial.println(" red first");
        count = 1;
        state = 2;
        break;
       }
      break;
    
    //this works
    case 2: // player chooses space code waits for player input
      
    if (numb >= 0 && numb <= 8 ) {
   /*   Serial.print(" state 2 ");
        Serial.print(" player chooses ");
        Serial.print(customKey);
        Serial.print(" light up neopixel ");
        Serial.print( numb );
        
        Serial.print(" customKey = ");
        Serial.print(customKey);
      
        Serial.print(" numb = ");
        Serial.println(numb);
    */  
        state = 3;
        break;
       }
   break;

      
    //this works
    case 3: // rule check: is space taken?
  //    Serial.print(" state 3  ");
      if (LED[numb / 3][numb % 3] == 0) { //space is not taken
    
   /*   Serial.print(" customKey = ");
        Serial.print(customKey);
        
        Serial.print(" numb = ");
        Serial.print(numb);
        
        Serial.println(" space is open ");
  */    state = 4;
        break;
       }

      if (LED[numb / 3][numb % 3] != 0) { //space is taken
   //     Serial.println(" space is taken ");      
        
   /*   Serial.print(" customKey = ");
        Serial.print(customKey);
        
        Serial.print(" numb = ");
        Serial.print(numb);
        
   */   state = 6;
        break;
        }
    break;
    
      //this works
    case 4: //light up neopixel
      if (color == 0  ) { //space is open & red's turn
        count = count + 1;
   /*  Serial.print(" state 4 ");
        Serial.print(" blue ");
        
        Serial.print(" customKey = ");
        Serial.print(customKey);
        
        Serial.print(" numb = ");
        Serial.print(numb);
  */      
        pixels.setPixelColor(numb, 0, 0, 255);
        pixels.show();
        
        X = numb / 3;         //assisgn the corrosponding x value for the array
        Y = numb % 3;         //assisgn the corrosponding y value for the array
        LED[X][Y] = 2;      //store the "red" value "1" in the array
        
    //    Serial.print(" LED ARRAY ");
    //    Serial.println( LED[X][Y] );        //store the "blue" value "2" in the array
        
        state = 5;
        break;
      }

      if (color == 1  ) { //space is open & blue's turn
        count = count + 1;
    //    Serial.print(" state 4  ");
    //    Serial.print(" red ");
        pixels.setPixelColor(numb, 255, 0, 0);
        pixels.show();
        
        X = numb / 3;         //assisgn the corrosponding x value for the array
        Y = numb % 3;         //assisgn the corrosponding y value for the array
        LED[X][Y] = 1;      //store the "blue" value "2" in the array
    
    //    Serial.print(" LED ARRAY ");
    //    Serial.println(LED[X][Y]);   //store the "red" value "1" in the array
        
        state = 5;
        break;
      }
    break;
    
      
   case 5:  // win detect
             
if((LED[0][0] == LED[1][0])&&(LED[0][0] == LED[2][0])&&(LED[1][0] == 1)){  // red column wins
//Serial.print(" red win on column 0 ");
state=8;
  break;}   

if((LED[0][1] == LED[1][1])&&(LED[0][1] == LED[2][1])&&(LED[1][1] == 1)){
//Serial.print(" red win on column 1 ");
state=8;
  break;}  

if((LED[0][2] == LED[1][2])&&(LED[0][2] == LED[2][2])&&(LED[1][2] == 1)){
//Serial.print(" red win on column 2 ");
state=8;
  break;}  

if((LED[0][0] == LED[1][0])&&(LED[0][0] == LED[2][0])&&(LED[1][0] == 2)){  // blue column wins
//Serial.print(" blue win on column 0 ");
state=9;
  break;}  

if((LED[0][1] == LED[1][1])&&(LED[0][1] == LED[2][1])&&(LED[1][1] == 2)){
//Serial.print(" blue win on column 1 ");
state=9;
  break;}

if((LED[0][2] == LED[1][2])&&(LED[0][2] == LED[2][2])&&(LED[1][2] == 2)){
//Serial.print(" blue win on column 2 ");
state=9;
  break;}    
        
if((LED[0][0] == LED[0][1])&&(LED[0][0] == LED[0][2])&&(LED[0][1] == 1)){  // red row wins
//Serial.print(" red win on row 0 ");
state=8;
  break;}

if((LED[1][0] == LED[1][1])&&(LED[1][0] == LED[1][2])&&(LED[1][1] == 1)){
//Serial.print(" red win on row 1 ");
state=8;
  break;}

if((LED[2][0] == LED[2][1])&&(LED[2][0] == LED[2][2])&&(LED[2][1] == 1)){
//Serial.print(" red win on row 2 ");
state=8;
  break;}

if((LED[0][0] == LED[0][1])&&(LED[0][0] == LED[0][2])&&(LED[0][1] == 2)){ // blue row wins
//Serial.print(" blue win on row 0 ");
state=9;
  break;}

if((LED[1][0] == LED[1][1])&&(LED[1][0] == LED[1][2])&&(LED[1][1] == 2)){
//Serial.print(" blue win on row 1 ");
state=9;
  break;}

if((LED[2][0] == LED[2][1])&&(LED[2][0] == LED[2][2])&&(LED[2][1] == 2)){
//Serial.print(" blue win on row 2 ");
state=9;
  break;}
     
        //diagnal
                     //left diagonal
      if ((LED[0][0] == LED[1][1]) && (LED[0][0] == LED[2][2]) && (LED[0][0] == 1)){
   //     Serial.print(" state 5 ");
   //       Serial.println(" red wins left diagonal ");          
         state = 8;
             break;
         }
      if ((LED[0][0] == LED[1][1]) && (LED[0][0] == LED[2][2]) && (LED[0][0] == 2)){
   //     Serial.print(" state 5  ");
   //       Serial.println(" blue wins left diagonal ");          
         state = 9;
             break;
        }
      
                        //right diagonal
      if ((LED[0][2] == LED[1][1]) && (LED[0][2] == LED[2][0]) && (LED[0][2] == 1)){
   //     Serial.print(" state 5  ");
   //         Serial.println(" red wins right diagonal ");    
            state = 8;
             break;
         }
      if ((LED[0][2] == LED[1][1]) && (LED[0][2] == LED[2][0]) && (LED[0][2] == 2 )){
   //       Serial.print(" state 5  ");
   //         Serial.println(" blue wins right diagonal ");
         state = 9;
           break;
         }
    
if(LED[0][0] == 0){
//Serial.print(" no win detected ");
//Serial.println("");
numb = -1;
state = 2;
break;
}
if(LED[1][0] == 0){
//Serial.print(" no win detected ");
//Serial.println("");
numb = -1;
state = 2;
break;
}
if(LED[2][0] == 0){
//Serial.print(" no win detected ");
//Serial.println("");
numb = -1;
state = 2;
break;
}
if(LED[0][1] == 0){
//Serial.print(" no win detected ");
//Serial.println("");
numb = -1;
state = 2;
break;
}
if(LED[1][1] == 0){
//Serial.print(" no win detected ");
//Serial.println("");
numb = -1;
state = 2;
break;
}
if(LED[2][1] == 0){
//Serial.print(" no win detected ");
//Serial.println("");
numb = -1;
state = 2;
break;
}
if(LED[0][2] == 0){
//Serial.print(" no win detected ");
//Serial.println("");
numb = -1;
state = 2;
break;
}
if(LED[1][2] == 0){
//Serial.print(" no win detected ");
//Serial.println("");
numb = -1;
state = 2;
break;
}
if(LED[2][2] == 0){
//Serial.print(" no win detected ");
//Serial.println("");
numb = -1;
state = 2;
break;
}    
      state = 7;
      break;  

      //does work
   case 6: // space taken animation
//  Serial.print(" state 6 space taken animation ");
     if(LED[numb / 3][numb % 3] == 1){    //if the space is taken by red
  //      Serial.println(" red ");

  pixels.setPixelColor(numb, 0, 0, 0);
  pixels.show();
  delay(200);
  
  pixels.setPixelColor(numb, 255, 0, 0);
  pixels.show();
  delay(200);
  
  pixels.setPixelColor(numb, 0, 0, 0);
  pixels.show();
  delay(200);
    
  pixels.setPixelColor(numb, 255, 0, 0);
  pixels.show();
    
      numb = -1;
      state = 2;
        break;
        } 
      
    if(LED[numb / 3][numb % 3] == 2){   //if the space is taken by blue
 //       Serial.println(" blue ");

  pixels.setPixelColor(numb, 0, 0, 0);
  pixels.show();
  delay(200);
  
  pixels.setPixelColor(numb, 0, 0, 255);
  pixels.show();
  delay(200);
  
  pixels.setPixelColor(numb, 0, 0, 0);
  pixels.show();
  delay(200);
    
  pixels.setPixelColor(numb, 0, 0, 255);
  pixels.show();
         
      numb = -1;
       state = 2;
       break;
      }
    break;

      //does work    
    case 7: // tie game animation
  //    Serial.println(" state 7 tie game animation ");
      delay(3000);
        for(i = 0; i<= 2;i++){
            for(numb = 0; numb <= 8; numb++){
              pixels.setPixelColor(numb, 255, 0, 0);
              delay(50);
              pixels.show();
              }
             

            for(numb = 0; numb <= 8; numb++){
              pixels.setPixelColor(numb, 0, 0, 255);
              delay(50);
              pixels.show();
              }
        
          for(numb = 0; numb <= 8; numb++){
              pixels.setPixelColor(numb, 0, 0, 0);
              delay(50);
              pixels.show();
              }
         
        }
            state = 10;
            break;


      //this works     
    case 8: // red win animation
//    Serial.println(" Red Win Animation ");  
  delay(1500);
    for(i = 0; i<= 2;i++){
      for(numb = 0; numb <= 8; numb++){
        pixels.setPixelColor(numb, 255, 0, 0);
        delay(50);
        pixels.show();
        }
      
        
      for(numb = 0; numb <= 8; numb++){
        pixels.setPixelColor(numb, 0, 0, 0);
        delay(50);
        pixels.show();
        }
    
  }
    state = 10;
        break;
    
      //this works    
    case 9: // blue win animation
 //     Serial.println(" Blue Win Animation "); 
    delay(1500);
   for(i = 0; i<= 2;i++){
    for(numb = 0; numb <= 8; numb++){
        pixels.setPixelColor(numb, 0, 0, 255);
        delay(50);
        pixels.show();
        }
     
        
      for(numb = 0; numb <= 8; numb++){
        pixels.setPixelColor(numb, 0, 0, 0);
        delay(50);
        pixels.show();
        }
    
   }
  
  
      state = 10;
        break;

    case 10: //holding pattern
pixels.setPixelColor(0, 0, 0, 255);
pixels.setPixelColor(1, 255, 0, 0);
pixels.setPixelColor(2, 0, 0, 255);
pixels.setPixelColor(3, 255, 0, 0); 
pixels.setPixelColor(4, 0, 0, 255);
pixels.setPixelColor(5, 255, 0, 0);  
pixels.setPixelColor(6, 0, 0, 255);
pixels.setPixelColor(7, 255, 0, 0); 
pixels.setPixelColor(8, 0, 0, 255);
pixels.show();
//  Serial.println(" Holding pattern ");

    break;
  }
      //does work
      if (customKey == 42) {  // reset game: press * to reset
  //      Serial.println(" ");
  //        Serial.println("reset");
      
        for(numb = 0; numb <= 8; numb++){
          pixels.setPixelColor(numb, 0, 0, 0);
          delay(200);
          pixels.show();
        }
                  
          for(i=0 ; i < 3; i++) {
        for(j=0 ; j < 3; j++) {
              LED[i][j]=0;}
          }
        numb = -1;
          
        state = 1;
      }
}


//this works
void Blinkred(int numb){

  pixels.setPixelColor(numb, 0, 0, 0);
  pixels.show();
  delay(200);
  
  pixels.setPixelColor(numb, 255, 0, 0);
  pixels.show();
  delay(200);
  
  pixels.setPixelColor(numb, 0, 0, 0);
  pixels.show();
  delay(200);
    
  pixels.setPixelColor(numb, 255, 0, 0);
  pixels.show();
  
}

//this works
void Blinkblue(int numb){
  
  pixels.setPixelColor(numb, 0, 0, 0);
  pixels.show();
  delay(200);
  
  pixels.setPixelColor(numb, 0, 0, 255);
  pixels.show();
  delay(200);
  
  pixels.setPixelColor(numb, 0, 0, 0);
  pixels.show();
  delay(200);
    
  pixels.setPixelColor(numb, 0, 0, 255);
  pixels.show();
  
}
    
